#ifndef FILEFUNC_H
#define FILEFUNC_H
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <glib.h>
#include <errno.h>
#include <string.h>

#include "minterface.h"
#include "msupport.h"

#define CHECK_FILE_OUTPUT 1
#define CHECK_FILE_BLOCK 2
#define CHECK_FILE_VALID 0

/* set outputfilecheck to CHECK_FILE_VALID if you just want to see
 * whether the file exists and/or is a regular file. Otherwise set it to
 * CHECK_FILE_OUPUT to check whether the file you are going to write to
 * has the proper permissions (if it exists or not) 
 *
 * msg can be NULL or a string which will be printed before the dialog
 * label
 * */
extern int check_filename(char *filename,int outputfilecheck,char *msg);

/* Checks whether a supplied file is a valid EPS file. If so returns 0
 * If it needs to convert it and succeeds, the it returns 1 and the
 * input string contains the new filename. If there is some failure it
 * will return -1 and you are expected to abort the current context */
extern int check_graphics(GtkWidget *anchor,char **filename);

extern void getdirs(char*, int*, GArray**);

#endif
