#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>

#include <gtk/gtk.h>
#include <glade/glade.h>

#include "minterface.h"
#include "id3.h"


int get_id3tag(char *filename, struct id3info *tag)
{
    /* If the file did'nt have an ID3 tag it returns -2 */

    int i, status;
    GtkWidget *w;
    GladeXML *xml;
    char *buf,*tmp;
    FILE *f;

   // struct id3info *tag = malloc( sizeof(struct id3info) * 1 );
    
    buf = malloc( sizeof(char) * 128 );
    tmp = malloc( sizeof(char) * 40 );

    f = fopen(filename,"rb");
    if (!f)
      {
        char *errstr, *e;
        errstr = strdup(strerror(errno));
        e = malloc( sizeof(char) * 
                ( strlen(errstr) +
                  strlen("Could'nt open file: : ") +
                  strlen(filename) + 1 ));
        sprintf(e,"Could'nt open file: %s: %s", filename, errstr);
        xml = create_error_dialog();
        w = glade_xml_get_widget(xml, "error_dialog_label");
        gtk_label_set_text(GTK_LABEL(w), e);
        free(e);
        return -1;
      }
    status = fseek(f,-128,SEEK_END);
    if (status != 0)
      {
        char *errstr, *e;
        errstr = strdup(strerror(errno));
        e = malloc( sizeof(char) * 
                ( strlen(errstr) +
                  strlen("Could'nt seek in file : ") +
                  strlen(filename) + 1 ));
        sprintf(e,"Could'nt seek in file: %s: %s", filename, errstr);
        xml = create_error_dialog();
        w = glade_xml_get_widget(xml, "error_dialog_label");
        gtk_label_set_text(GTK_LABEL(w), e);
        free(e);
        fclose(f);
        return -1;
      }

    status = fread(buf, 128, 1, f);
    if (status != 1)
      {
        char *errstr, *e;
        errstr = strdup(strerror(errno));
        e = malloc( sizeof(char) * 
                ( strlen(errstr) +
                  strlen("Could'nt read from file : ") +
                  strlen(filename) + 1 ));
        sprintf(e,"Could'nt read from file: %s: %s", filename, errstr);
        xml = create_error_dialog();
        w = glade_xml_get_widget(xml, "error_dialog_label");
        gtk_label_set_text(GTK_LABEL(w), e);
        free(e);
        fclose(f);
        return -1;
      }

    if (!strncmp(buf,"TAG",3))
      {
        buf = buf+3;
        strncpy(tmp, buf, 30);
        tmp[29] = '\0';
        tag->title = g_locale_to_utf8(tmp, strlen(tmp), NULL, NULL, NULL);
        if (!tag->title)
            tag->title = strdup("");

        buf = buf + 30;
        strncpy(tmp, buf, 30);
        tmp[29] = '\0';
        tag->artist = g_locale_to_utf8(tmp, strlen(tmp), NULL, NULL, NULL);
        if (!tag->artist)
            tag->artist = strdup("");

        buf = buf + 30;
        strncpy(tmp, buf, 30);
        tmp[29] = '\0';
        tag->album = g_locale_to_utf8(tmp, strlen(tmp), NULL, NULL, NULL);
        if (!tag->album)
            tag->album = strdup("");

        //free(buf);
        //free(tmp);
        fclose(f);
        return 0;
      }
    else
      {
        /*
        char *errstr, *e;
        errstr = strdup(strerror(errno));
        e = malloc( sizeof(char) * 
                ( strlen(errstr) +
                  strlen("Does'nt have an ID3 tag : ") +
                  strlen(filename) + 1 ));
        sprintf(e,"Does'nt have an ID3 tag: %s", filename);
        xml = create_error_dialog();
        w = glade_xml_get_widget(xml, "error_dialog_label");
        gtk_label_set_text(GTK_LABEL(w), e);
        free(e);

        free(buf);
        free(tmp);

        fclose(f);
        */
        return -2;
      }
}





