/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <getopt.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/stat.h>
#include <unistd.h>
#include <glob.h>

#include "minterface.h"
#include "msupport.h"
#include "configparse.h"
#include "gtkcdlabel.xpm"
#include "filefunc.h"

#define OPTSTRING "hV"

void window_set_icon(GtkWidget *window, char *icon);

static const struct option long_options[] =
{
      {"help", no_argument, NULL, 'h'},
      {"version", no_argument, NULL, 'V'},

      { 0, 0, 0, 0 },
};

void window_set_icon(GtkWidget *window, char *icon)
{
	GdkPixmap *pixmap;
        GdkBitmap *mask;

	gtk_widget_realize (window);
	
	pixmap = gdk_pixmap_create_from_xpm_d (window->window, &mask,
                                		&window->style->bg[GTK_STATE_NORMAL],
                                		(char **)gtkcdlabel_xpm);
	
	gdk_window_set_icon (window->window, NULL, pixmap, mask);
}
static void usage(int status)
{
    if (status != EXIT_SUCCESS)
        fprintf(stderr, "Try %s --help' for more information.\n",
                g_get_prgname());
    else {
        printf("Usage: %s [OPTION ...]\n", g_get_prgname());
        fputs ("\n\
                -h, --help              display this help and exit\n\
                -V, --version           output version information and exit\n\
                \n\
                Report bugs to <rajarshi@presidency.com>.\n",
                stdout);
    }
    gtk_exit(status);
}


int main (int argc, char *argv[])
{
    GtkWidget *w,*c;
    GladeXML *window1xml;
    
    FILE *popen(),*in;
    char *tmp,*errorbuffer,*command;
    char buffer[100];
    int status;
    struct stat buf;
    
    gint optchar;
    gboolean opt_help = FALSE;
    gboolean opt_version = FALSE;
    int numbindir = 42;
    static char *bindirs[] = {
        "/bin",
        "/usr/bin",
        "/sbin",
        "/usr/sbin",
        "/etc",
        "/usr/etc",
        "/lib",
        "/usr/lib",
        "/usr/games",
        "/usr/games/bin",
        "/usr/games/lib",
        "/usr/emacs/etc",
        "/usr/lib/emacs/*/etc",
        "/usr/TeX/bin",
        "/usr/tex/bin",
        "/usr/interviews/bin/LINUX",
        "/usr/X11R6/bin",
        "/usr/X386/bin",
        "/usr/bin/X11",
        "/usr/X11/bin",
        "/usr/X11R5/bin",
        "/usr/local/bin",
        "/usr/local/sbin",
        "/usr/local/etc",
        "/usr/local/lib",
        "/usr/local/games",
        "/usr/local/games/bin",
        "/usr/local/emacs/etc",
        "/usr/local/TeX/bin",
        "/usr/local/tex/bin",
        "/usr/local/bin/X11",
        "/usr/contrib",
        "/usr/hosts",
        "/usr/include",
        "/usr/g++-include",
        "/usr/ucb",
        "/usr/old",
        "/usr/new",
        "/usr/local",
        "/usr/libexec",
        "/usr/share",
        "/opt/*/bin",
    };

#ifdef ENABLE_NLS
    bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
    bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
    textdomain (GETTEXT_PACKAGE);
#endif

    gtk_set_locale ();
    gtk_init (&argc, &argv);

    while ((optchar = getopt_long(argc, argv, OPTSTRING,
                    long_options, NULL)) != EOF)
      {
        switch (optchar)
          {
            default:
                usage(EXIT_FAILURE);

            case 0:
                break;

            case 'h':
                opt_help = TRUE;
                break;          

            case 'V':
                opt_version = TRUE;
                break;             
          }
      }    

    if (opt_help)
        usage(EXIT_SUCCESS);

    if (opt_version) {
        printf ("%s %s\n", PACKAGE, VERSION);
        gtk_exit(EXIT_SUCCESS);
    }

    add_pixmap_directory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");

    /*
     * The following code was added by Glade to create one of each component
     * (except popup menus), just so that you see something after building
     * the project. Delete any components that you don't want shown initially.
     */
    window1xml = create_window1();
    w = glade_xml_get_widget(window1xml,"window1");

    /* we set the default values for the config entry boxes here */
    c = lookup_widget( GTK_WIDGET(w), "cdlabelgen_entry");
    gtk_entry_set_text( GTK_ENTRY(c), "/usr/bin/cdlabelgen");
    
    c = lookup_widget( GTK_WIDGET(w), "lpr_entry");
    gtk_entry_set_text( GTK_ENTRY(c), "/usr/bin/lpr");

    c = lookup_widget( GTK_WIDGET(w), "viewer_entry");
    gtk_entry_set_text( GTK_ENTRY(c), "/usr/bin/ggv");

    c = lookup_widget( GTK_WIDGET(w), "ps_entry");
    gtk_entry_set_text( GTK_ENTRY(c), "/usr/share/cdlabelgen/");

    c = lookup_widget( GTK_WIDGET(w), "entry_cddb");
    gtk_entry_set_text( GTK_ENTRY(c), "/dev/cdrom");

    c = lookup_widget( GTK_WIDGET(w), "cddbserver_entry");
    gtk_entry_set_text( GTK_ENTRY(c), "freedb.freedb.org");

    c = lookup_widget( GTK_WIDGET(w), "mountpointentry");
    gtk_entry_set_text( GTK_ENTRY(c), "/mnt/cdrom");

    c = lookup_widget( GTK_WIDGET(w), "template_entry");
    gtk_entry_set_text( GTK_ENTRY(c), "/usr/share/cdlabelgen/template.ps");

    /* check for /usr/bin/convert, /usr/local/bin/convert adn set the
     * default value to the first one, or else, keep it blank */
    status = stat("/usr/bin/convert", &buf);
    if ( (status == -1 && errno == ENOENT) || !S_ISREG(buf.st_mode) )
      {
        status = stat("/usr/local/bin/convert", &buf);
        if ( (status == -1 && errno == ENOENT) || !S_ISREG(buf.st_mode) )
          {}
        else
          {
            c = lookup_widget( GTK_WIDGET(w), "convert_entry");
            gtk_entry_set_text( GTK_ENTRY(c), "/usr/local/bin/convert");
          }
      }
    else
      {
        c = lookup_widget( GTK_WIDGET(w), "convert_entry");
        gtk_entry_set_text( GTK_ENTRY(c), "/usr/bin/convert");
      }

    window_set_icon(GTK_WIDGET(w), "gtkcdlabel_xpm");
    load_config(w);
    
    /* We should see whether the users version of cdlabelgen supports
     * the -n & -C options. If not then desensitize the two check
     * buttons on the UI 
     *
     * We cant rely on the location of cdlabelgen specified in the entry
     * box. So we try it. If it does'nt work we try and do a glob
     * on the bindirs[]. If its found in one of them notify the user but
     * dont change the value of the text entry
     * */
    c = lookup_widget (GTK_WIDGET (w), "cdlabelgen_entry");
    tmp = (gchar*)get_entry_text_in_locale( c );                                        
    status = stat(tmp, &buf);
    if (status == -1 && errno == ENOENT)
      {
        /* ok we need to do a glob :( */
        int i,j;
        char *path;
        glob_t g;

        path = malloc(sizeof(char) * 
                (strlen(bindirs[0]) + strlen("cdlabelgen") + 2));
        sprintf(path,"%s/cdlabelgen",bindirs[0]);        
        glob(path, GLOB_NOSORT|GLOB_ERR, NULL, &g);

        /* Collect all the matches */
        for (i = 1; i < numbindir; i++)
          {
            path = malloc(sizeof(char) * 
                    (strlen(bindirs[i]) + strlen("cdlabelgen") + 2));
            sprintf(path,"%s/cdlabelgen",bindirs[i]);
            status = glob(path, GLOB_NOSORT|GLOB_ERR|GLOB_APPEND, NULL, &g);
            free(path);
          }

        /* Now see if any of the matches are regular files */
        for (i = 0; i < g.gl_pathc; i++)
          {
            stat(g.gl_pathv[i], &buf);
            if ( S_ISREG(buf.st_mode) ) // maybe I should check for +x?
              {
                if (strcmp(tmp,g.gl_pathv[i]))
                  {
                    fprintf(stderr,"\n\tThe path to cdlabelgen in your settings and the path\n"
                            "\tthat I found do not match. The path I found is:\n\n"
                            "\t\t%s\n\n"
                            "\tMake sure to update your settings\n\n",g.gl_pathv[i]);
                  }
                tmp = strdup(g.gl_pathv[i]);
                goto gotcdlabelgen;
              }
          }
        // if we're here we did'nt find a regular file called cdlabelgen
        fprintf(stderr,"\n\tIt seems I could'nt find cdlabelgen on your system\n"
                "\tPlease install it! (Or if its there move it into\n"
                "\tone of the standard paths)\n\n");
        globfree(&g);
        exit(0);
      }

gotcdlabelgen:
    command = malloc(sizeof(char) * (strlen(tmp) + 10));
    sprintf(command,"%s -h",tmp);
    

    /* get the output from cdlabelgen */
    errorbuffer = malloc(sizeof(char) * MAXLINE);
    errorbuffer[0] = '\0';
    in = popen(command, "r");
    while (fgets(buffer, 100, in) != NULL)
      {
        if (strlen(errorbuffer) + strlen(buffer) > MAXLINE)
          {
            errorbuffer = realloc(errorbuffer, sizeof(char) * (strlen(errorbuffer) + strlen(buffer) + 1));
            errorbuffer[ strlen(errorbuffer) - 1] = '\0';
          }
        strcat(errorbuffer , buffer);
      }
    if (!strstr(errorbuffer,"-n, "))
      {
        c = lookup_widget( GTK_WIDGET(w), "volume_entry");
        gtk_widget_set_sensitive( c, FALSE );
        c = lookup_widget( GTK_WIDGET(w), "no_cover_plaque");
        gtk_widget_set_sensitive( c, FALSE );
      }
    fclose(in);
    free(command);
    free(errorbuffer);

    gtk_main ();
    return 0;
}

