/*
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <glade/glade.h>
#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "mcallbacks.h"
#include "minterface.h"
#include "msupport.h"

#include "ui.h"
#include "pixmap.h"


GladeXML *create_window1 (void)
{
    GladeXML *xml;
    GtkWidget *w,*b;
    GdkColor color;
    int i;
    
    GtkStyle *style;
    GtkWidget *pixmapwid;
    GdkPixmap *pixmap;
    GdkBitmap *mask;
    GtkWidget *child;

    gchar *eps_select_file_key = "varname";
    gchar *tray_select_file_key = "varname";

    xml = glade_xml_new_from_buffer(uistr,strlen(uistr),"window1", NULL);
    glade_xml_signal_autoconnect(xml);

    
    /* For the buttons in the Setup tab we attach the corresponding text
     * entry object to them 
     */
    w = glade_xml_get_widget(xml,"cdlabelgenentry_button");
    b = glade_xml_get_widget(xml,"cdlabelgen_entry");
    g_object_set_data( G_OBJECT(w), "entrywidget", (gpointer)b );
    
    w = glade_xml_get_widget(xml,"viewerentry_button");
    b = glade_xml_get_widget(xml,"viewer_entry");
    g_object_set_data( G_OBJECT(w), "entrywidget",  (gpointer)b );
    
    w = glade_xml_get_widget(xml,"lprentry_button");
    b = glade_xml_get_widget(xml,"lpr_entry");
    g_object_set_data( G_OBJECT(w), "entrywidget",  (gpointer)b );
    
    w = glade_xml_get_widget(xml,"psentry_button");
    b = glade_xml_get_widget(xml,"ps_entry");
    g_object_set_data( G_OBJECT(w), "entrywidget",  (gpointer)b );
    
    w = glade_xml_get_widget(xml,"cddbentry_button");
    b = glade_xml_get_widget(xml,"entry_cddb");
    g_object_set_data( G_OBJECT(w), "entrywidget",  (gpointer)b );
    
    w = glade_xml_get_widget(xml,"templatenetry_button");
    b = glade_xml_get_widget(xml,"template_entry");
    g_object_set_data( G_OBJECT(w), "entrywidget",  (gpointer)b );

    w = glade_xml_get_widget(xml,"eps_select_file");
    b = glade_xml_get_widget(xml,"entry_eps_filename");
    g_object_set_data( G_OBJECT(w), "entrywidget",  (gpointer)b );

    w = glade_xml_get_widget(xml,"tray_select_file");
    b = glade_xml_get_widget(xml,"entry_tray_filename");
    g_object_set_data( G_OBJECT(w), "entrywidget",  (gpointer)b );

    w = glade_xml_get_widget(xml,"mountpointentry_button");
    b = glade_xml_get_widget(xml,"mountpointentry");
    g_object_set_data( G_OBJECT(w), "entrywidget",  (gpointer)b );

    w = glade_xml_get_widget(xml,"convertentry_button");
    b = glade_xml_get_widget(xml,"convert_entry");
    g_object_set_data( G_OBJECT(w), "entrywidget",  (gpointer)b );
    
    w = glade_xml_get_widget(xml,"window1");
    style = gtk_widget_get_style( w );
    pixmap = gdk_pixmap_create_from_xpm_d (w->window, &mask,
            &style->bg[GTK_STATE_NORMAL],
            bold_italic_xpm);
    pixmapwid = gtk_image_new_from_pixmap(pixmap,mask);
    gtk_widget_show( pixmapwid );
    w = glade_xml_get_widget(xml,"italicboldbutton");
    child = gtk_bin_get_child( GTK_BIN(w) );
    gtk_widget_destroy( GTK_WIDGET(child) );
    gtk_container_add (GTK_CONTAINER (w),pixmapwid);

    
    return(xml);
}

GladeXML *create_yesnodialog (void)
{
    GladeXML *xml;

    xml = glade_xml_new_from_buffer(uistr,strlen(uistr),"yesnodialog",NULL);
    glade_xml_signal_autoconnect(xml);
    
    return (xml);
}

GladeXML *create_error_dialog (void)
{
    GladeXML *xml;

    xml = glade_xml_new_from_buffer(uistr,strlen(uistr), "error_dialog", NULL);
    glade_xml_signal_autoconnect(xml);

    return (xml);
}

GladeXML *create_cdlabelgen_error(void)
{
    GladeXML *xml;
    
    xml = glade_xml_new_from_buffer(uistr,strlen(uistr), "cdlabelgen_error", NULL);
    glade_xml_signal_autoconnect(xml);

    return (xml);
}

GladeXML *create_color_dialog(GtkWidget *toplevel, GtkWidget *da)
{
    /* If *da is NULL then this function was called from a button,
     * otherwise it was called by clicking on a drawing area. After
     * we're done (by clicking OK) we should repaint the supplied
     * drawing area
     */
    
    GladeXML *xml;
    GtkWidget *w;

    xml = glade_xml_new_from_buffer(uistr, strlen(uistr), "colorselectiondialog", NULL);
    glade_xml_signal_autoconnect(xml);

    /* Attach the user specified toplevel window to this the color
     * selection dialog window */
    w = glade_xml_get_widget(xml,"colorselectiondialog");
    g_object_set_data( G_OBJECT(w), "toplevel", (gpointer)toplevel );
    g_object_set_data( G_OBJECT(w), "da", (gpointer)da );

    return(xml);
}

